/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Offline教材 オフラインログのbk-i数字タグデータ保持クラス
//			変更履歴
//				2004.01.08	新規作成	二條　智文
//
package jp.co.ntt.lms.lo.Offline.OfflineLog;

import org.w3c.dom.*;
import java.util.*;

/**
 * Offline教材 オフラインログのbk-i数字タグデータ保持クラス<BR>
 * オフラインログのbk-i数字ノードを受け取り、自身の内部変数にデータを
 * 格納します。
 */
public class OfflineBkLog implements OfflineLogConst {

	// 自身のノードオブジェクトを保持します。
	private Element mobjBkLogElm = null;

	// エラーメッセージ
	private static final String ERR_PRE = "<loms>-<lom>-<bk>--<i数字>:";
	private static final String ERR_INVALID_TAGNAME = ERR_PRE + "タグ名が不正です。";

	// 属性保持
	// タグ名の数値を保持します。
	private int mintTagNo;
	// <lom>-<bk>-<i数字>-<id>の値を保持します。
	private String mstrID;
	// <lom>-<bk>-<i数字>-<time>の値を保持します。
	private String mstrTime;
	// <lom>-<bk>-<i数字>-<type>の値を保持します。
	private String mstrType;
	// <lom>-<bk>-<i数字>-<weighting>の値を保持します。
	private String mstrWeighting;
	// <lom>-<bk>-<i数字>-<student_response>の値を保持します。
	private String mstrStudentResponse;
	// <lom>-<bk>-<i数字>-<result>の値を保持します。
	private String mstrResult;
	// <lom>-<bk>-<i数字>-<latency>の値を保持します。
	private String mstrLatency;

	// <lom>-<bk>-<i数字>-<objectives>-<i数字>-<id>の値
	private Vector mvecObjectivesID = new Vector();

	// <lom>-<bk>-<i数字>-<correct_response>-<i数字>-<pattern>の値
	private Vector mvecPattern = new Vector();

	/**
	 * コンストラクタです。
	 * @param objNode bk-i数字エレメントオブジェクト
	 * @exception OfflineLogParseException パースエラー
	 */
	OfflineBkLog( Element objElement )
		throws OfflineLogParseException
	{
		// タグ名のチェック
		String strTagName = objElement.getTagName();
		if( strTagName.charAt(0) == LOM_BK_PRE ) {

			// 'i' の次の文字が数字のものを探す
			try {
				String strNum = strTagName.substring( 1, strTagName.length() );

				// 数値に変換する。
				mintTagNo = Integer.parseInt( strNum );
			}
			catch( NumberFormatException ne ) {
				throw new OfflineLogParseException( ERR_INVALID_TAGNAME );
			}
			catch( IndexOutOfBoundsException  ie ) {
				throw new OfflineLogParseException( ERR_INVALID_TAGNAME );
			}
		}
		else {
			// 'i'で始まらない場合はエラーとする
			throw new OfflineLogParseException( ERR_INVALID_TAGNAME );
		}

		mobjBkLogElm = objElement;

		parse();

	}

	/**
	 * タグ名の数字を取得します。
	 * @return int タグ名の数字
	 */
	public int getTagNo() {
		return mintTagNo;
	}

	/**
	 * <lom>-<bk>-<i数字>-<id>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String  <lom>-<bk>-<i数字>-<id>の値
	 */
	public String getID() {
		return mstrID;
	}

	/**
	 * <lom>-<bk>-<i数字>-<time>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String  <lom>-<bk>-<i数字>-<time>の値
	 */
	public String getTime() {
		return mstrTime;
	}

	/**
	 * <lom>-<bk>-<i数字>-<type>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String  <lom>-<bk>-<i数字>-<type>の値
	 */
	public String getType() {
		return mstrType;
	}

	/**
	 * <lom>-<bk>-<i数字>-<weighting>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String  <lom>-<bk>-<i数字>-<weighting>の値
	 */
	public String getWeighting() {
		return mstrWeighting;
	}

	/**
	 * <lom>-<bk>-<i数字>-<student_response>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String  <lom>-<bk>-<i数字>-<student_response>の値
	 */
	public String getStudentResponse() {
		return mstrStudentResponse;
	}

	/**
	 * <lom>-<bk>-<i数字>-<result>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String  <lom>-<bk>-<i数字>-<result>の値
	 */
	public String getResult() {
		return mstrResult;
	}

	/**
	 * <lom>-<bk>-<i数字>-<latency>の値を取得します。
	 * 存在しない場合はnullを返します。
	 * @return String  <lom>-<bk>-<i数字>-<latency>の値
	 */
	public String getLatency() {
		return mstrLatency;
	}

	/**
	 * <lom>-<bk>-<i数字>-<objectives>-<i数字>-<id>の値をカンマ区切りで区切った
	 * 文字列を返します。
	 * @return String <lom>-<bk>-<i数字>-<objectives>-<i数字>-<id>の値を
	 *                カンマ区切りで区切った文字列
	 */
	public String getObjectivesID() {

		if( mvecObjectivesID.size() == 0 ) {
			return null;
		}

		StringBuffer sbID = new StringBuffer();
		for( int i = 0; i < mvecObjectivesID.size(); i++ ) {
			String strID = (String)mvecObjectivesID.get(i);
			if( strID != null ) {
				sbID.append( strID );
				sbID.append( "," );
			}
		}

		String strRes = "";
		if( sbID.length() > 0 ) {
			strRes = sbID.substring( 0, sbID.length() -1 );
		}
		else {
			strRes = new String( sbID );
		}
		return strRes;
	}

	/**
	 * <lom>-<bk>-<i数字>-<correct_response>-<i数字>-<pattern>の値をカンマ区切りで区切った
	 * 文字列を返します。
	 * @return String <lom>-<bk>-<i数字>-<correct_response>-<i数字>-<pattern>の値を
	 *                カンマ区切りで区切った文字列
	 */
	public String getCorrectResponse() {

		if( mvecPattern.size() == 0 ) {
			return null;
		}

		StringBuffer sbPattern = new StringBuffer();
		for( int i = 0; i < mvecPattern.size(); i++ ) {
			String strID = (String)mvecPattern.get(i);
			if( strID != null ) {
				sbPattern.append( strID );
				sbPattern.append( "," );
			}
		}

		String strRes = "";
		if( sbPattern.length() > 0 ) {
			strRes = sbPattern.substring( 0, sbPattern.length() -1 );
		}
		else {
			strRes = new String( sbPattern );
		}
		return strRes;
	}

//------------------------------------ 内部関数 --------------------------------
	/**
	 * コンストラクタで受け取ったエレメントないのデータを
	 * 取得して、自身の変数に格納します。
	 */
	private void parse()
		throws OfflineLogParseException
	{

		// <lom>-<bk>-<i数字>-<id>の値を取得する
		mstrID = OfflineUtil.getNodeValueFromNodeName( LOM_BKLOG_ID, mobjBkLogElm );
		// <lom>-<bk>-<i数字>-<time>の値を取得する
		mstrTime = OfflineUtil.getNodeValueFromNodeName( LOM_BKLOG_TIME, mobjBkLogElm );
		// <lom>-<bk>-<i数字>-<type>の値を取得する
		mstrType = OfflineUtil.getNodeValueFromNodeName( LOM_BKLOG_TYPE, mobjBkLogElm );
		// <lom>-<bk>-<i数字>-<weighting>の値を取得する
		mstrWeighting = OfflineUtil.getNodeValueFromNodeName( LOM_BKLOG_WEIGHTING, mobjBkLogElm );
		// <lom>-<bk>-<i数字>-<studeng_response>の値を取得する
		mstrStudentResponse = OfflineUtil.getNodeValueFromNodeName( LOM_BKLOG_STUDENT_RESPONSE, mobjBkLogElm );
		// <lom>-<bk>-<i数字>-<result>の値を取得する
		mstrResult = OfflineUtil.getNodeValueFromNodeName( LOM_BKLOG_RESULT, mobjBkLogElm );
		// <lom>-<bk>-<i数字>-<latency>の値を取得する
		mstrLatency = OfflineUtil.getNodeValueFromNodeName( LOM_BKLOG_LATENCY, mobjBkLogElm );


		// <lom>-<bk>-<i数字>-<objectives>-<i数字>-<id>の値の取得
		NodeList objObjectives = mobjBkLogElm.getElementsByTagName( BK_OBJECTIVES );
		NodeList objList = null;

		if( objObjectives.getLength() > 0 ) {

			Element objObjectivesElm = (Element)objObjectives.item(0);
			objList = objObjectivesElm.getChildNodes();

			for( int i = 0; i < objList.getLength(); i++ ) {

				Node objNodeTemp = objList.item( i );

				String strNodeTitle = objNodeTemp.getNodeName();

				// ノード名が'i'で始まるノードを探す
				if( strNodeTitle.charAt(0) == BK_OBJECTIVES_PRE ) {

					// 'i' の次の文字が数字のものを探す
					try {
						String strNum = strNodeTitle.substring( 1, strNodeTitle.length() );

						// 数値に変換する。
						int intNum = Integer.parseInt( strNum );

						mvecObjectivesID.add( OfflineUtil.getNodeValueFromNodeName( BK_OBJECTIVES_ID, (Element)objNodeTemp ) );
					}
					catch( NumberFormatException ne ) {}
					catch( IndexOutOfBoundsException  ie ) {}
				}
			}
		}

		// <lom>-<bk>-<i数字>-<correct_response>-<i数字>-<pattern>の値の取得
		NodeList objCorrectResponse = mobjBkLogElm.getElementsByTagName( BK_CORRECT_RESPONSE );

		if( objCorrectResponse.getLength() > 0 ) {

			Element objCorrectResponseElm = (Element)objCorrectResponse.item(0);
			objList = objCorrectResponseElm.getChildNodes();

			for( int i = 0; i < objList.getLength(); i++ ) {

				Node objNodeTemp = objList.item( i );

				String strNodeTitle = objNodeTemp.getNodeName();

				// ノード名が'i'で始まるノードを探す
				if( strNodeTitle.charAt(0) == BK_CORRECT_RESPONSE_PRE ) {

					// 'i' の次の文字が数字のものを探す
					try {
						String strNum = strNodeTitle.substring( 1, strNodeTitle.length() );

						// 数値に変換する。
						int intNum = Integer.parseInt( strNum );

						mvecPattern.add( OfflineUtil.getNodeValueFromNodeName( BK_CORRECT_RESPONSE_PATTERN, (Element)objNodeTemp ) );
					}
					catch( NumberFormatException ne ) {}
					catch( IndexOutOfBoundsException  ie ) {}
				}
			}
		}

	}
//------------------------------------ 内部関数 --------------------------------
}

